section ".text"  class_code
section "data"  class_data

include DisplayBmp.inc

MENUOFFSET              equ 0B4h

.data
pResource:
INCBIN Rsrc.bin

msg         db 'Displaying a bitmap from file',0
title1      db 'About',0
pFile       db 'Chessboard.bmp',0

hBitmap     dd ?
hMem        dd ?
width       dd ?
height      dd ?
ps          PAINTSTRUCT ?
_rect       RECT ?

IDM_ABOUT   equ 11
IDM_EXIT    equ 12
IDC_ABOUT   equ 110
IDC_EXIT    equ 120
IDC_EDIT    equ 3000
ID_BITMAP   equ 1000

.entry _start

..text

_start:

        invoke GetModuleHandle,0
        invoke DialogBoxIndirectParam,eax,pResource,0,DlgProc,0
        invoke ExitProcess,eax

PROC    DlgProc 
ARG     hWnd,uMsg,wParam,lParam
LOCAL   hDC
LOCAL   hMemDC
LOCAL   hFile
LOCAL   nFileSize
LOCAL   size1

    .IF [uMsg] == WM_INITDIALOG
;int3
        lea     eax,[pResource+MENUOFFSET]  ; Res2obj outputs the offset values during the conversion process

	mov	eax,pResource
	add	eax,MENUOFFSET

        invoke  LoadMenuIndirect,eax        ; from .res to .bin       
        invoke  SetMenu,[hWnd],eax

        invoke  CreateFile,pFile,GENERIC_READ,\
                0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
        mov     [hFile],eax
        invoke  GetFileSize,eax,0
        mov     [nFileSize],eax
        invoke  VirtualAlloc,0,eax,MEM_COMMIT,PAGE_EXECUTE_READWRITE
        mov     [hMem],eax
        lea     edx,[size1]
        invoke  ReadFile,[hFile],eax,[nFileSize],edx,0
        invoke  CloseHandle,[hFile]

        invoke  GetDC,[hWnd]
        mov     [hDC],eax
        mov     edx,[hMem]
        lea     ecx,[edx + BITMAPFILEHEADER]  ; start of BITMAPINFOHEADER header
        push    [ecx+BITMAPINFOHEADER.biWidth]
        pop     [width]
        push    [ecx+BITMAPINFOHEADER.biHeight]
        pop     [height]
        mov     eax,[edx+BITMAPFILEHEADER.bfOffBits]
        add     edx,eax
        invoke  CreateDIBitmap,[hDC],ecx,CBM_INIT,edx,ecx,DIB_RGB_COLORS
        mov     [hBitmap],eax
        invoke  ReleaseDC,[hWnd],[hDC]
        invoke  VirtualFree,[hMem],0,MEM_RELEASE

    .ELSEIF [uMsg] == WM_PAINT
   
        invoke  BeginPaint,[hWnd],ps
        mov     [hDC],eax
        invoke  CreateCompatibleDC,[hDC]
        mov     [hMemDC],eax
        invoke  SelectObject,[hMemDC],[hBitmap]
        invoke  BitBlt,[hDC],0,0,width,height,[hMemDC],0,0,SRCCOPY
        invoke  DeleteDC,[hMemDC]
        invoke  EndPaint,[hWnd],ps

    .ELSEIF [uMsg] == WM_CLOSE

        invoke SendMessage,[hWnd],WM_COMMAND,IDM_EXIT,0

    .ELSEIF [uMsg] == WM_COMMAND
		
        mov eax,[wParam]
        .IF [lParam] == 0
        
            .IF ax == IDM_ABOUT
            
                invoke  MessageBox,0,msg,title1,MB_OK
            .ELSEIF ax == IDM_EXIT
            
                invoke  DeleteObject,[hBitmap]
                invoke  EndDialog,[hWnd],0
            .ENDIF
        .ELSE
            mov edx,[wParam]
            shr edx,16
            .IF dx == BN_CLICKED
                               
                .IF ax == IDC_ABOUT
                    invoke  SendMessage,[hWnd],WM_COMMAND,IDM_ABOUT,0
                .ELSEIF ax == IDC_EXIT
                    invoke  SendMessage,[hWnd],WM_COMMAND,IDM_EXIT,0
                .ENDIF
            .ENDIF
        .ENDIF

	.ELSE

    mov eax,FALSE
    ret

    .ENDIF

    mov eax,TRUE
    ret

ENDP

